/******************************************************************************
*                                                                             *
* xfsconf.h     WOSA/XFS - definitions for the Configuration functions        *
*                                                                             *
*               Version 1.11  --  3 Feb 1995                                  *
*                                                                             *
******************************************************************************/
 
#ifndef __INC_XFSCONF__H
#define __INC_XFSCONF__H

#ifdef __cplusplus
extern "C" {
#endif

/******* Common **************************************************************/

#include    <xfsapi.h>

/*   be aware of alignment   */
#pragma pack(push,1)

// following HKEY and PHKEY are already defined in WINREG.H
// so definition has been removed
// typedef HANDLE  HKEY;
// typedef HANDLE * PHKEY;

/******* Value of hKey *******************************************************/

#define     WFS_CFG_HKEY_XFS_ROOT               ((HKEY)1)

/******* Values of lpdwDisposition *******************************************/

#define     WFS_CFG_CREATED_NEW_KEY             (0)
#define     WFS_CFG_OPENED_EXISTING_KEY         (1)

/******* Configuration Functions *********************************************/

HRESULT extern  WINAPI  WFMCloseKey ( HKEY );
HRESULT extern  WINAPI  WFMCreateKey ( HKEY, LPSTR, PHKEY, LPDWORD );
HRESULT extern  WINAPI  WFMDeleteKey ( HKEY, LPSTR );
HRESULT extern  WINAPI  WFMDeleteValue ( HKEY, LPSTR );
HRESULT extern  WINAPI  WFMEnumKey ( HKEY, DWORD, LPSTR, LPDWORD, PFILETIME );
HRESULT extern  WINAPI  WFMEnumValue ( HKEY, DWORD, LPSTR, LPDWORD, LPSTR, LPDWORD );
HRESULT extern  WINAPI  WFMOpenKey ( HKEY, LPSTR, PHKEY );
HRESULT extern  WINAPI  WFMQueryValue ( HKEY, LPSTR, LPSTR, LPDWORD );
HRESULT extern  WINAPI  WFMSetValue ( HKEY, LPSTR, LPSTR, DWORD );


/*   restore alignment   */
#pragma pack(pop)

#ifdef __cplusplus
}       /*extern "C"*/
#endif

#endif  /* __INC_XFSCONF__H */
